/*
 * File: parity.c
 * Author: Russell J Clark
 * Date: September 24, 1995
 *
 * This is the parity calculator function for the nwsim system.
 */

/*
 *
 * CalculateParity(data,length)
 * 
 * Performs a bitwise parity calculation on the data given.
 * Arguments:
 *		data is a unsigned char pointer
 * 		length is in bytes.
 *
 * Returns a parity bit in the low-order bit of a unsigned char.
 * 
 */
unsigned char CalculateEvenParity(data,length)
register unsigned char *data;
register int	length;
{
    register unsigned short parity = 0;
    register int byte, bitcount;
    register unsigned char bit;
    register unsigned char temp, *dataptr ;

    dataptr = data;

    for (byte=0; byte < length; byte++)
    {
	temp = *dataptr;
	bit = 1; 

	for (bitcount=0; bitcount < 8; bitcount++ )
	{
	    if (temp & bit)
		parity = ~parity & 0x0001;

	    bit = bit << 1;
	}
	dataptr++;
    }

    return(parity);
} /* CalculateEvenParity */
